'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Text = require('./Text');

var _Text2 = _interopRequireDefault(_Text);

var _ValidationError = require('../ValidationError');

var _ValidationError2 = _interopRequireDefault(_ValidationError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Number = function (_React$Component) {
  _inherits(Number, _React$Component);

  function Number() {
    _classCallCheck(this, Number);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Number).apply(this, arguments));
  }

  _createClass(Number, [{
    key: 'getValue',
    value: function getValue() {
      return this.refs.inp.getValue();
    }
  }, {
    key: 'validate',
    value: function validate(value) {
      var _this2 = this;

      var _props = this.props;
      var name = _props.name;
      var minValue = _props.minValue;
      var minValueMsg = _props.minValueMsg;
      var maxValue = _props.maxValue;
      var maxValueMsg = _props.maxValueMsg;

      return this.refs.inp.validate(value).then(function (v) {
        var num = parseFloat(v);
        if (isNaN(num)) {
          return Promise.reject(new _ValidationError2.default(_this2, name, "Value is not a number"));
        }

        if (minValue !== undefined && num < minValue) {
          return Promise.reject(new _ValidationError2.default(_this2, name, minValueMsg || "Value must be greater than or equals to " + minValue));
        }
        if (maxValue !== undefined && num > maxValue) {
          return Promise.reject(new _ValidationError2.default(_this2, name, maxValueMsg || "Value must be less than or equals to " + maxValue));
        }

        return num;
      });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(_Text2.default, _extends({ ref: 'inp' }, this.props));
    }
  }]);

  return Number;
}(_react2.default.Component);

exports.default = Number;